diff --git a/libi3/draw_util.c b/libi3/draw_util.c
index e7e7c09c9..b20b46dee 100644
--- a/libi3/draw_util.c
+++ b/libi3/draw_util.c
@@ -23,6 +23,12 @@ xcb_visualtype_t *visual_type;
 /* Forward declarations */
 static void draw_util_set_source_color(xcb_connection_t *conn, surface_t *surface, color_t color);
 
+#define CHECK_SURFACE(surface)                                               \
+    if (surface->id == XCB_NONE) {                                           \
+        ELOG("Surface %p is not initialized, skipping drawing.\n", surface); \
+        return;                                                              \
+    }
+
 /*
  * Initialize the surface to represent the given drawable.
  *
@@ -104,6 +110,8 @@ color_t draw_util_colorpixel_to_color(uint32_t colorpixel) {
  *
  */
 static void draw_util_set_source_color(xcb_connection_t *conn, surface_t *surface, color_t color) {
+    CHECK_SURFACE(surface);
+
 #ifdef CAIRO_SUPPORT
     cairo_set_source_rgb(surface->cr, color.red, color.green, color.blue);
 #else
@@ -120,6 +128,8 @@ static void draw_util_set_source_color(xcb_connection_t *conn, surface_t *surfac
  *
  */
 void draw_util_text(i3String *text, surface_t *surface, color_t fg_color, color_t bg_color, int x, int y, int max_width) {
+    CHECK_SURFACE(surface);
+
 #ifdef CAIRO_SUPPORT
     /* Flush any changes before we draw the text as this might use XCB directly. */
     CAIRO_SURFACE_FLUSH(surface->surface);
@@ -141,6 +151,8 @@ void draw_util_text(i3String *text, surface_t *surface, color_t fg_color, color_
  *
  */
 void draw_util_rectangle(xcb_connection_t *conn, surface_t *surface, color_t color, double x, double y, double w, double h) {
+    CHECK_SURFACE(surface);
+
 #ifdef CAIRO_SUPPORT
     cairo_save(surface->cr);
 
@@ -171,6 +183,8 @@ void draw_util_rectangle(xcb_connection_t *conn, surface_t *surface, color_t col
  *
  */
 void draw_util_clear_surface(xcb_connection_t *conn, surface_t *surface, color_t color) {
+    CHECK_SURFACE(surface);
+
 #ifdef CAIRO_SUPPORT
     cairo_save(surface->cr);
 
@@ -201,6 +215,9 @@ void draw_util_clear_surface(xcb_connection_t *conn, surface_t *surface, color_t
  */
 void draw_util_copy_surface(xcb_connection_t *conn, surface_t *src, surface_t *dest, double src_x, double src_y,
                             double dest_x, double dest_y, double width, double height) {
+    CHECK_SURFACE(src);
+    CHECK_SURFACE(dest);
+
 #ifdef CAIRO_SUPPORT
     cairo_save(dest->cr);
 
diff --git a/src/x.c b/src/x.c
index c432c1aeb..8a5bb7c9a 100644
--- a/src/x.c
+++ b/src/x.c
@@ -518,7 +518,7 @@ void x_draw_decoration(Con *con) {
     if (p->border_style != BS_NORMAL)
         goto copy_pixmaps;
 
-    /* If the parent hasn't been set up yet, skip the decoratin rendering
+    /* If the parent hasn't been set up yet, skip the decoration rendering
      * for now. */
     if (parent->frame_buffer.id == XCB_NONE)
         goto copy_pixmaps;
